'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;


  var plugins = {};

  (0, _lodash.each)((0, _glob.sync)((0, _path.join)(__dirname, 'plugins', '*.js')), function (plugin) {
    (0, _lodash.extend)(plugins, require(plugin));
  });

  return {
    visitor: {
      CallExpression: function CallExpression(nodePath, state) {
        var node = nodePath.node;
        var fn = state.opts.fn || 'inject';

        if (node.callee.name === fn && node['arguments'].length == 1) {
          var value = node['arguments'][0].value;
          var ext = (0, _path.extname)(value).substr(1);

          if ((0, _lodash.isString)(value)) {

            var args = { src: value, t: t, nodePath: nodePath, state: state };

            if (plugins[value] !== undefined) {
              nodePath.replaceWithSourceString(plugins[value](args));
            } else if ((0, _lodash.isFunction)(plugins[ext])) {

              var res = plugins[ext](args);

              if (typeof res === 'function') {
                nodePath.replaceWithSourceString(res);
              } else {
                nodePath.replaceWith(t.valueToNode(res));
              }
            } else {
              nodePath.replaceWith(t.nullLiteral());
            }
          }
        }
      }
    }
  };
};

var _glob = require('glob');

var _lodash = require('lodash');

var _path = require('path');